## 游戏实名认证服务

![](/uploads/publicsdk/images/m_21e7301d40f3b2829c1e717296a38d00_r.png)
![](/uploads/publicsdk/images/m_bd21ca7f3909be69945adda85adbba53_r.png)
#### 主要内容：
* 游戏请求接口，Redis内存响应大部分请求，不存在数据再请求mysql.写入时先写入mysql,成功后再写入Redis.
* 读写即时更新在Redis,每次接收到请求，根据lastUpdateTime更新重置日在线累计和月充值累计，Redis再根据情况同步到Mysql.
* 实名验证接口使用腾讯云第三方接口。

## 游戏接入
游戏异步调用Get查询，没有返回实名信息，在适当位置显示实名认证图标，用Post方式添加玩家实名认证。
### 1) 请求实名状态

>https://cid.gzyouai.com/api/v1/default/cid

#### 调用方式：HTTP get

#### 接口描述：


#### 请求参数:

##### GET参数:
| 字段名称 |                         字段说明                          |  类型  | 必填 | 备注 |
| -------- | :-------------------------------------------------------: | :----: | :--: | ---: |
| oid      | 渠道返回唯一账号id(接入公共的建议是"userType_渠道openid") | string |  Y   |    - |




### 请求返回结果:

```
//请求返回信息 ymd:生日 online：在线时长（分钟 没有设置过默认不传） amount:累计充值(元 没有设置过默认不传)
{"code":200,"data":{ymd:'20200101',online:"60",amount:"150"},"msg":"ok"}

```

#### 返回结果:
| 字段名称 | 字段说明 |  类型  | 必填 |                                  备注 |
| -------- | :------: | :----: | :--: | ------------------------------------: |
| code     |   状态   | string |  Y   |             200成功,10002，账号不存在 |
| data     |   内容   |  json  |  Y   | 成功为实名后年月日,不存在为空json对象 |
| msg      | 提示信息 | string |  Y   |                                       |

#### 例子：
https://cid.gzyouai.com/api/v1/default/cid?oid=userType_4243289



### 2) 实名验证接口

>https://cid.gzyouai.com/api/v1/default/cid

### 调用方式：HTTP post

### 接口描述：


### 请求参数:

#### GET参数:
| 字段名称 |      字段说明      |  类型  | 必填 | 备注 |
| -------- | :----------------: | :----: | :--: | ---: |
| oid      | 渠道返回唯一账号id | string |  Y   |    - |
| num      |   用户绑定身份证   | string |  Y   |    - |
| name      |   用户姓名   | string |  Y   |    - |



### 请求返回结果:

```
//
{"code":200,"data":"","msg":"ok"}
or 
{"code":10001,"msg":"已存在该实名验证","data":""}

```

#### 返回结果:
| 字段名称 | 字段说明 |  类型  | 必填 |                            备注 |
| -------- | :------: | :----: | :--: | ------------------------------: |
| code     |   状态   | string |  Y   | 200成功,10001，已存在该实名验证 |
| data     |   内容   |  json  |  Y   |                    为空json对象 |
| msg      | 提示信息 | string |  Y   |                                 |

#### 例子：
```
curl -X POST https://cid.gzyouai.com/api/v1/default/cid -d 'oid=userType_4243289&num=330502880702447&name=多多'

```

### 3) 更新信息接口 (更新在线时长和充值金额)

>https://cid.gzyouai.com/api/v1/default/update

### 调用方式：HTTP post

### 接口描述：


### 请求参数:

#### GET参数:
| 字段名称 |      字段说明      |  类型  | 必填 | 备注 |
| -------- | :----------------: | :----: | :--: | ---: |
| oid      | 渠道返回唯一账号id | string |  Y   |    - |
| type      |   online/amount   | string |  Y   |    - |
| value      |   值   | string |  Y   |    - |



### 请求返回结果:

```
//请求返回信息 ymd:生日 online：在线时长（分钟） amount:累计充值(元)
{"code":200,"data":{ymd:'20200101',online:"60",amount:"150"},"msg":"ok"}
or 
{"code":10001,"data":"","msg":"已存在该实名验证"}

```

#### 返回结果:
| 字段名称 | 字段说明 |  类型  | 必填 |                            备注 |
| -------- | :------: | :----: | :--: | ------------------------------: |
| code     |   状态   | string |  Y   | 200成功,10001，已存在该实名验证 |
| data     |   内容   |  json  |  Y   |                    为空json对象 |
| msg      | 提示信息 | string |  Y   |                                 |

#### 例子：
```
curl -X POST https://cid.gzyouai.com/api/v1/default/update -d 'oid=userType_4243289&type=online&value=10'
curl -X POST https://cid.gzyouai.com/api/v1/default/update -d 'oid=userType_4243289&type=amount&value=10'

curl -X POST http://127.0.0.1:8000/api/v1/default/update -d 'oid=userType_4243289&type=amount&value=10'

```

### 其它接口待添加

## 总结

```
//请求实名接口
curl https://cid.gzyouai.com/api/v1/default/cid?oid=userType_4243289
//验证实名接口
curl -X POST https://cid.gzyouai.com/api/v1/default/cid -d 'oid=userType_4243289&num=330502880702447&name=多多'
//更新月充值和日时长
curl -X POST https://cid.gzyouai.com/api/v1/default/update -d 'oid=userType_4243289&type=online&value=10'
curl -X POST https://cid.gzyouai.com/api/v1/default/update -d 'oid=userType_4243289&type=amount&value=10'

```

## 接入发送申请邮件
上面地址为测试地址方便接入，对应游戏地址请请找平台人员申请 
```
[标题]项目组-游戏名-申请接入实名验证
[项目负责人] xxx
[运营对接人员] xxx qq/手机
[对接目的] 游戏自研联运发行/其它
[日均在线用户数] 400w
[对接公共SDK] 是/否
```