## 游戏实名认证服务

![](/uploads/publicsdk/images/m_21e7301d40f3b2829c1e717296a38d00_r.png)
![](/uploads/publicsdk/images/m_bd21ca7f3909be69945adda85adbba53_r.png)
#### 主要内容：
* 游戏请求接口，Redis内存响应大部分请求，不存在数据再请求mysql.写入时先写入mysql,成功后再写入Redis.
* 读写即时更新在Redis,每次接收到请求，根据lastUpdateTime更新重置日在线累计和月充值累计，Redis再根据情况同步到Mysql.
* 实名验证接口使用国家规定实名接口。

## 游戏接入
游戏异步调用Get查询，没有返回实名信息，在适当位置显示实名认证图标，用Post方式添加玩家实名认证。
### 1) 请求实名状态

>https://cid.gzyouai.com/api/v2/default/cid

#### 调用方式：HTTP get

#### 接口描述：


#### 请求参数:

##### GET参数:
| 字段名称 |                         字段说明                          |  类型  | 必填 | 备注 |
| -------- | :-------------------------------------------------------: | :----: | :--: | ---: |
| oid      | 渠道返回唯一账号id(接入公共的建议是"userType_渠道openid") | string |  Y   |     |
| key      | 公共接口分配的游戏项目参数 | string |  Y   |    - |



### 请求返回结果:

```
//请求返回信息 ymd:生日 online：在线时长（分钟 没有设置过默认不传） amount:累计充值(元 没有设置过默认不传)
{"code":200,"data":{ymd:'20200101',online:"60",amount:"150"},"msg":"ok"}

```

#### 返回结果:
| 字段名称 | 字段说明 |  类型  | 必填 |                                  备注 |
| -------- | :------: | :----: | :--: | ------------------------------------: |
| code     |   状态   | string |  Y   |             200成功 |
| data     |   内容   |  json  |  Y   | 成功为实名后年月日,不存在为空json对象，如果认证中YMD记录为 "1"|
| msg      | 提示信息 | string |  Y   |                                       |

#### 例子：
https://cid.gzyouai.com/api/v2/default/cid?oid=userType_4243289&key=cda56c8c89fbdc38adc51bb42dc3eb8d



### 2) 实名验证接口

>https://cid.gzyouai.com/api/v2/default/cid

### 调用方式：HTTP post

### 接口描述：


### 请求参数:

#### GET参数:
| 字段名称 |      字段说明      |  类型  | 必填 | 备注 |
| -------- | :----------------: | :----: | :--: | ---: |
| oid      | 渠道返回唯一账号id | string |  Y   |    - |
| num      |   用户绑定身份证   | string |  Y   |    - |
| name      |   用户姓名   | string |  Y   |    - |
| key      |   公共接口分配的游戏项目参数   | string |  Y   |    - |



### 请求返回结果:

```
//
{"code":200,"data":"","msg":"ok"}
or 
{"code":10001,"msg":"已存在该实名验证","data":""}

```

#### 返回结果:
| 字段名称 | 字段说明 |  类型  | 必填 |                            备注 |
| -------- | :------: | :----: | :--: | ------------------------------: |
| code     |   状态   | string |  Y   | 200成功,10001，已存在该实名验证 |
| data     |   内容   |  json  |  Y   |                    为空json对象 |
| msg      | 提示信息 | string |  Y   |      长度最长32位，不然会返回 "参数错误"                          |

#### 例子：
```
curl -X POST https://cid.gzyouai.com/api/v2/default/cid -d 'oid=userType_4243289&num=330502880702447&name=多多&key=cda56c8c89fbdc38adc51bb42dc3eb8d'

```

### 3) 上报信息接口 (更新在线时长和充值金额)

>https://cid.gzyouai.com/api/v2/default/update

### 调用方式：HTTP post

### 接口描述：


### 请求参数:

#### GET参数:
| 字段名称 |      字段说明      |  类型  | 必填 | 备注 |
| -------- | :----------------: | :----: | :--: | ---: |
| oid      | 渠道返回唯一账号id | string |  Y   |    - |
| type      |   online/amount/login/logout   | string |  Y   |    **要求login/logout必须接入** |
| value      |   值   | string |  N   |    online/amount时需要填新增金额或时长 |
| key      |   公共接口分配的游戏项目参数   | string |  Y   |    - |
| di      |   设备号   | string |  Y   |     |




### 请求返回结果:

```
{"code":200,"data":"","msg":"ok"}
or
{"code":400,"msg":"请求参数错误","data":""}

```

#### 返回结果:
| 字段名称 | 字段说明 |  类型  | 必填 |                            备注 |
| -------- | :------: | :----: | :--: | ------------------------------: |
| code     |   状态   | string |  Y   | 200成功 |
| data     |   内容   |  json  |  Y   |                    为空json对象 |
| msg      | 提示信息 | string |  Y   |                                 |

#### 例子：
```
curl -X POST https://cid.gzyouai.com/api/v2/default/update -d 'oid=userType_4243289&type=online&value=10&key=cda56c8c89fbdc38adc51bb42dc3eb8d&di=xxx'
curl -X POST https://cid.gzyouai.com/api/v2/default/update -d 'oid=userType_4243289&type=amount&value=10&key=cda56c8c89fbdc38adc51bb42dc3eb8d&di=xxx'

curl -X POST http://127.0.0.1:8000/api/v2/default/update -d 'oid=userType_4243289&type=amount&value=10&key=cda56c8c89fbdc38adc51bb42dc3eb8d&di=xxx'

```

### 其它接口待添加

## 总结

```
//请求实名接口
curl https://cid.gzyouai.com/api/v2/default/cid?oid=userType_4243289&key=cda56c8c89fbdc38adc51bb42dc3eb8d
//验证实名接口
curl -X POST https://cid.gzyouai.com/api/v2/default/cid -d 'oid=userType_4243289&num=330502880702447&name=多多&key=cda56c8c89fbdc38adc51bb42dc3eb8d'
//更新月充值和日时长
curl -X POST https://cid.gzyouai.com/api/v2/default/update -d 'oid=userType_4243289&type=online&value=10&key=cda56c8c89fbdc38adc51bb42dc3eb8d&di=xxx'
curl -X POST https://cid.gzyouai.com/api/v2/default/update -d 'oid=userType_4243289&type=amount&value=10&key=cda56c8c89fbdc38adc51bb42dc3eb8d&di=xxx'

//上报登陆登出
curl -X POST https://cid.gzyouai.com/api/v2/default/update -d 'oid=userType_4243289&type=login&key=cda56c8c89fbdc38adc51bb42dc3eb8d&di=xxx'
curl -X POST https://cid.gzyouai.com/api/v2/default/update -d 'oid=userType_4243289&type=logout&key=cda56c8c89fbdc38adc51bb42dc3eb8d&di=xxx'

```

## 接入发送申请邮件
上面地址为测试地址方便接入，游爱内部游戏需要在政府实名后台获取到参数(正式参数）后，添加106.54.82.128和121.5.210.49到IP白名单，发送邮件到技术中心申请对接参数，发给运营中心负责人 赵毅春 zhaoyichun@gzyouai.com 抄送 赵楚凡zhaochufan@gzyouai.com 莫洪章 mohongzhang@gzyouai.com 外部游戏请找平台对应人员。
```
[标题]项目组-游戏名-申请实名接口参数
[项目负责人] xxx
[运营对接人员] xxx qq/手机
[对接目的] 游戏自研联运发行/其它
[日均在线用户数] 400w
[对接公共SDK] 是/否
[参数] 游戏简称/appId/bizId/secretKey
[是否已添加白名单] 是/否
 例：游戏简称：fytx
 	appId:test-appId(正式参数）
	bizId:test-bizId(正式参数）
	secretkey:xxxxxx(正式参数）
	主体公司名称：xxx
	
需要多套参数的提交多个游戏。服务端接入用文档接口
```