[TOC]
# 公共实名安卓SDK接入文档

## 接入准备 [点我跳转下载SDK相关资源](http://gitlab.9133.com/public_service/public_sdk_android/tree/master/doc/%E5%85%AC%E5%85%B1%E5%AE%9E%E5%90%8DSDK%E6%8E%A5%E5%85%A5 "点我跳转下载SDK相关资源")

# **！！本SDK用途为政府实名认证上报工作！！**

### 1. 找相关负责人获取参数
serverUrl：服务器域名 默认 https://cid.gzyouai.com
gameSimpleName：游戏在公共后台的项目版本代号 如 fytx_test
key：公共接口分配的游戏项目参数
### 2. 拷贝jar包文件 PublicFcmSDK.jar 到你的项目工程
### 3. 在你的项目工程 AndroidManifest.xml 文件中添加
```xml
<activity
		android:name="com.publicfcm.sdk.PublicFcmSDKUserCertificationView"
		android:configChanges="keyboard|keyboardHidden|orientation|screenSize|screenLayout"
		android:theme="@android:style/Theme.Translucent.NoTitleBar.Fullscreen">
</activity>
```

## 接口介绍
### 1. init 初始化（必接）

|   Activity| 上下文  |
| ------------ | ------------ |
|  serverUrl | 服务器域名  |
|  gameSimpleName | 游戏简称  |
|  key | 分配的上传key  |
| PublicFcmSDKListener  | SDK回调  |


```java
PublicFcmSDK.getInstance().init(Activity activity, String serverUrl, String gameSimpleName, String key, PublicFcmSDK.PublicFcmSDKListener publicFcmSDKListener);
```

例子

```java
PublicFcmSDK.getInstance().init(this, "https://cid.gzyouai.com", "default", "cda56c8c89fbdc38adc51bb42dc3eb8d", new PublicFcmSDK.PublicFcmSDKListener() {
            @Override
            public void userInfo(int totalGameTime, int totalPayMoney, String birthday) {
                PoolSdkLog.logError("游戏收到回调：totalGameTime:" + totalGameTime + ",totalPayMoney:" + totalPayMoney+",birthday:"+birthday);
            }

            @Override
            public void error(String errMsg) {
                PoolSdkLog.logError("游戏收到回调：errMsg:" +errMsg);
            }

            @Override
            public void result(Object data) {
                PoolSdkLog.logError("游戏收到回调：result:" +data);
            }
        });
```

### 2. getUserInfo 获取用户信息（选接）
|  Activity |上下文   |
| ------------ | ------------ |
| openID  |  用户openID |

```java
PublicFcmSDK.getInstance().getUserInfo(Activity context,String openID);
```

例子

```java
PublicFcmSDK.getInstance().getUserInfo(this,"550_123");
```
### 3. updateUserData 上传用户行为（必接）

| Activity  | 上下文  |
| ------------ | ------------ |
| openID  | 用户openID  |
| type  |  登录为 PublicFcmSDK.FcmSDKUserType.LOGIN 下线为 PublicFcmSDK.FcmSDKUserType.LOGOUT |

```java
PublicFcmSDK.getInstance().updateUserData(Activity context, String openID, String type);
```

例子

```java
PublicFcmSDK.getInstance().updateUserData(this,"550_123", PublicFcmSDK.FcmSDKUserType.LOGIN);
```

### 4. openUserCertificationView 打开实名认证界面（4、5必接1个）（游戏项目无自己实名认证界面可以用公共统一提供的）

| Activity  |上下文   |
| ------------ | ------------ |
| openID  | 用户openID  |


```java
PublicFcmSDK.getInstance().openUserCertificationView(Activity context,String openID);
```

例子

```java
PublicFcmSDK.getInstance().openUserCertificationView(this,"550_123");
```

### 5. setUserCertification 实名认证（4、5必接1个）（游戏项目有自己的实名认证界面可以调用该接口进行实名信息上报）

| Activity  | 上下文  |
| ------------ | ------------ |
| openID  |   用户openID |
|  name | 姓名  |
| idNumber  |  身份证号码 |


```java
PublicFcmSDK.getInstance().setUserCertification(Activity context,String openID,String name,String idNumber);
```

例子

```java
PublicFcmSDK.getInstance().setUserCertification(this,"550_123","尚福乐", "211322198509260317");
```

### 6. PublicFcmSDK.PublicFcmSDKListener 回调

| userInfo  |获取用户信息接口 getUserInfo 的回调|
| ------------ | ------------ |
| error  | 上报接口报错信息回调  |
|  result |  上报用户行为和实名认证结果回调 |


```java
public abstract interface PublicFcmSDKListener {
        public abstract void userInfo(int totalGameTime, int totalPayMoney, String birthday);
        public abstract void error(String errMsg);
        public abstract void result(Object data);
}
```