# 公共SDK服务端接入文档

### 1.登录验证
	客户端发送请求参数给服务端,服务端对参数进行 MD5 加密,如果加密结果和serverSign 一致,则验证通过,否则不通过
参数 			| 类型 				| 描述
------------ 	| ------------- 	| ------------
userType 		| int  				| 用户类型 ID(渠道类型,兼容以 前帐号体系)
openId 			| string  			| 平台渠道方返回用户ID
timestamp 		| string  			| 时间戳,公共SDK发送到客户端的参数timestamp, 服务端可以判断 timestamp 是否 在有效的登录时间内
serverSign 		| string  			| 验证密钥,公共 SDK 发送到 客户端的参数 serverSign,加密串:gameAppkey=%s&userType=% s&openId=%s&timestamp=%s注意:(改为游戏本身的gameAppkey值)

验证方式:  
serverSign=MD5(gameAppkey=%s&userType=%s&openId=%s&timestamp=%s) 如:
md5("gameAppkey=xxxx&userType=1&openId=123&timestamp=111111111111")  
gameAppkey : 在公共SDK后台的 Md5加密的KEY

`注意!CP必须要以userType+openId保证帐号唯一性`

### 2. 充值验证(通知游戏方发货)
	公共SDK服务器接收到渠道服务器充值回调,对回调进行 MD5 验证,如果验证通过, 则采用Post方式马上回调给游戏充值服务器,否则不会回调充值服务器,然后再返回 信息给渠道服务器。回调参数如下:
参数 			| 类型 			| 描述
------------ 	| -------------| ------------
serverId 		| int  			| 服务器 ID
playerId 		| int  			| 角色 ID
orderId 		| string  		| 渠道方订单 ID
payAmount 		| double  		| 充值金额(如有商品 ID,此值为商 品的金额, 单位元)
currency 		| string  		| 充值货币(CNY:人民币)
goodsId 		| string  		| 商品ID,参数对一些有商品列表 的充值有效
goodsName 		| string  		| 商品名称
remoteIp 		| string  		| 客户端充值 IP
custom	 		| string  		| 透传参数 ,长度 512
serverSign 		| string  		| 发给充值服务器验证的注意:(改为游戏本身的 gameAppkey 值)
uId 			| string  		| 平台渠道帐号 ID
gameSimpleName 	| string  		| 平台SDK后台游戏代号名
sdkSimpleName 	| string  		| 平台SDK代号
queryId 		| string  		| 平台SDK订单号
postTime 		| string  		| 订单创建时间戳
sign 		    | string  		| 升级Md5加密的值

验证方式:  
旧:serverSign=MD5(serverId=%s&playerId=%s&orderId=%s&gameAppKey=%s)  
升级:sign=Md5('serverId=%s&playerId=%s&orderId=%s&payAmount=%s&goodsId=%s&sdkSimpleName=%s&gameAppKey=%s')  
%s:为相应的值  
gameAppkey : 在公共SDK后台的Md5加密的KEY  
验证通过后,返回公共 SDK 服务器数据,数据格式:{"code":0,"message":"无订 单"}。code:0 表示失败,1 表示成功,message:描述原因。 

`注意!CP必须要以orderId+sdkSimpleName保证订单唯一性,建议使用sign验证`

### 3. 网页下单(渠道使用)-不常用
	请求地址 : 运营获取
	请求类型 : post
	参数:
参数 			| 类型 			| 描述
------------ 	| -------------| ------------
data 		| string  			| 标准json字符串,内容参见以下说明
	
	data字段说明:
参数 			| 类型 			| 描述
------------ 	| -------------| ------------
serverId 		| int  			| 服务器 ID
playerId 		| int  			| 角色 ID
postAmount 		| double  		| 充值金额(如有商品 ID,此值为商 品的金额, 单位元)
productId 		| string  		| 商品ID,参数对一些有商品列表 的充值有效
productName 		| string  		| 商品名称
custom	 		| string  		| 透传参数 ,长度 512
userId 			| string  		| 平台渠道帐号 ID


	返回内容:

参数 			| 类型 			| 描述
------------ 	| -------------| ------------
message 		| string  			| 请求报错时候的错误信息
code 		| int  			| 请求结果: 1 成功, 其他为失败
data 		| json  			| json字典, 内容参见以下说明
	
	data字段说明:
参数 			| 类型 			| 描述
------------ 	| -------------| ------------
postTime 		| int  			| 下单timestamp
serverId 		| int  			| 服务器 ID(重要)
playerId 		| int  			| 角色 ID(重要)
postAmount 		| double  		| 充值金额(如有商品 ID,此值为商 品的金额, 单位元)(重要)
productId 		| string  		| 商品ID,参数对一些有商品列表 的充值有效(重要)
custom	 		| string  		| 透传参数 ,长度 512(重要)
uId 			| string  		| 平台渠道帐号 ID(重要)
gameSimpleName 	| string  		| 平台SDK后台游戏代号名
sdkSimpleName 	| string  		| 平台SDK代号
queryId 	| string  		| 平台订单号(重要)
products 	| json  		| 商品表,苹果用


	请求结果参考::
	{'message': '', 'code': 1, 'data': {'postTime': 1566040451, 'danjiConfig': '', 'uId': u'2587803', 'playerId': u'4351590982', 'sdkSimpleName': u'apple_shenshou', 'custom': u'1#0#', 'currency': 'CNY', 'other': '', 'products': {u'com.gzss.rsrzrcj.328': {u'amount': u'328', u'name': u'3280\u91d1\u5e01'}, u'com.gzss.rsrzrcj.648': {u'amount': u'648', u'name': u'6480\u91d1\u5e01'}, u'com.gzss.rsrzrcj.68': {u'amount': u'68', u'name': u'680\u91d1\u5e01'}, u'com.gzss.rsrzrcj.198': {u'amount': u'198', u'name': u'1980\u91d1\u5e01'}, u'com.gzss.rsrzrcj.6': {u'amount': u'6', u'name': u'60\u91d1\u5e01'}, u'com.gzss.rsrzrcj.25': {u'amount': u'25', u'name': u'\u6708\u5361'}, u'com.gzss.rsrzrcj.30': {u'amount': u'30', u'name': u'300\u91d1\u5e01'}}, 'remoteIp': '211.97.130.143', 'postAmount': 6.0, 'queryId': '2019081719141186011839B6', 'serverId': u'4150', 'gameSimpleName': u'1031', 'productId': u'1001'}}


### 4. 充值服务器IP地址
	180.184.161.139
	180.184.171.182
	180.184.161.184
	180.184.161.63