# 乐游服务端请求以及和前端交互的接口如下：
## 登录(和前端交互)

    请求链接： https://sdk.hahplatform.com/static/sdk1_0_0/client.html?action=login&app_id=6007e26eb6ee064428e16d96&app_key=4c3ce5d31f10cfb3922c652063f519ed&isSwitch=true&uuid=&idfv=&device_info=10&ver=20210126&timestamp=1611655228785&lng=en-US

| 参数 | 说明 |
|------------|---------|
| action | 动作，登录就为 login |
| app_id | 运营给的参数 |
| app_key | 运营给的参数 |
| isSwitch | 是否是切换账号，是 true ，不是 false |
| timestamp | 时间戳 |
| lng | 当前用户的语言 |

## 第三方账号登录返回乐游账号(和后端交互)

### 请求事例：
    https://sdk.hahplatform.com/sdk/sso/login?app_id=6007e26eb6ee064428e16d96&openid=112304055357683206858&sso_name=ACTION SOFA&sso_type=google&sign=2a087a5bcaef15c3c41656186975c1ce
    
    请求方式： GET

| 参数 | 说明 |
|------------|---------|
| app_id | 运营给的参数 |
| openid | 登录返回的 |
| sso_name | 第三方平台返回的用户名 |
| sso_type | 要绑定的平台，google 或 facebook |
| sign | 请求链接加上 appkey的参数 再md5的值 |

### 返回事例：
    {"code":0,"msg":{"share_str": "", "username": "google_06858_67", "google": "112304055357683206858", "apple": "", "bind_phone": "", "open_id": 1549, "timestamp": 1611735800, "login_count": 4, "mail": "", "bind_mail_statu": 0, "token": "5db0e83b4a69da9a6e2b6d1cf3d185b0", "notify_url": "https://sdk.hahplatform.com/service/confirm/google/5458c012e138231304af4216", "facebook": "", "login_key": "131e82317d50eb55cd35be161d5ea53d", "float_button": 0, "pay_channel_id": "5458c012e138231304af4216", "is_guest": 0, "kefu_info": ["Facebook：@Leyou"], "nickname": "google_06858_67", "share_pic": "", "bind_statu": 0}}

| 参数 | 说明 |
|------------|---------|
| code | 0 代表成功 |
| float_button | 悬浮球 |
| login_count | 登录次数 |
| login_key | login_key |
| notify_url | 确认订单地址 |
| open_id | open_id |
| pay_channel_id | pay_channel_id |
| share_pic | facebook分享的图片链接 |
| share_str | facebook分享的图片描述 |
| timestamp | 时间戳 |
| token | token |

## 乐游账号绑定第三方账号(和后端交互)

### 请求事例：
    https://sdk.hahplatform.com/sdk/sso/bind?app_id=6007e26eb6ee064428e16d96&login_key=297fa17cfee1e02913603b1ddfecf5ff&open_id=1614&openid=112304055357683206858&sso_name=&sso_type=google&sign=bc7ead9d99ea86941c7ce35c14a312c2
    
    请求方式： GET

| 参数 | 说明 |
|------------|---------|
| app_id | 运营给的参数 |
| login_key | 登录返回的 |
| openid | 登录返回的 |
| sso_name | 第三方平台返回的用户名 |
| sso_type | 要绑定的平台，google 或 facebook |
| sign | 请求链接加上 appkey的参数 再md5的值 |

### 返回事例：
    {"code":0,"msg":"success"}

| 参数 | 说明 |
|------------|---------|
| code | 0 代表成功 |

## 第三方账号解绑(和后端交互)

### 请求事例：
    https://sdk.hahplatform.com/sdk/sso/bind?action=unbind&app_id=6007e26eb6ee064428e16d96&login_key=131e82317d50eb55cd35be161d5ea53d&open_id=1549&openid=112304055357683206858&sso_name=&sso_type=google&sign=61e6556112acedfd5d6e10d00e14a5a8
    
    请求方式： GET

| 参数 | 说明 |
|------------|---------|
| action | unbind |
| app_id | 运营给的参数 |
| login_key | 登录返回的 |
| openid | 登录返回的 |
| sso_name | 第三方平台返回的用户名 |
| sso_type | 要绑定的平台，google 或 facebook |
| sign | 请求链接加上 appkey的参数 再md5的值 |

### 返回事例：
    {"code":0,"msg":"解绑成功"}

| 参数 | 说明 |
|------------|---------|
| code | 0 代表成功 |

## 请求语言数据(和后端交互)

### 请求链接
    http://10.19.200.42:9009/static/sdk1_0_0/locales/en-US.json

    请求方式：GET ， en-US 代表请求的是英文数据，zh-TW 代表繁体 ，其他的请自行和运营商量

    返回：json字符串，自行解析所需数据

## 支付(和后端交互)

### 创建订单

#### 请求事例： 
    role_name=WalkerPag&encode=0&login_key=95f5d5d214cf66e661851ec8c55b2576&pay_channel_id=5458c012e138231304af4216&productid=beauty_00099_1&money=0.99&open_id=1609&role_id=2100297844&callback=202101271450147228852699&game_amount=9&serverid=2003&app_id=6007e26eb6ee064428e16d96

    请求方式：POST 表单提交

| 参数 | 说明 | 备注 |
|------------|---------|------|
| callback | 公共订单号 |  |
| open_id | 登录返回的数据 |  |
| login_key | 登录返回的数据 |  |
| serverid | 游戏区服 |  |
| productid | 内购id |  |
| role_name | 玩家角色名称 |  |
| role_id | 玩家角色id |  |
| pay_channel_id | 登录返回的数据 |  |
| game_amount | 游戏传过来的金额和比率之积 |  |
| money | 游戏传过来的金额 |  |
| app_id | 运营给的参数 |  |
| encode | 是否加密，0 不加，1 加 |  |

#### 返回事例： 

    {"code":0,"msg":{"youai_star": 99, "pay_param": {"next_url": "", "query_id": "60110d281a65d320ffdc4f95"}, "amount": 0.99, "game_unit": "个", "kefu_info": ["Facebook：@Leyou"], "game_unit_name": "金币", "trade_id": "60110d281a65d320ffdc4f94", "game_amount": 9}}

| 参数 | 说明 |
|------------------------|---------|
| code | 0 代表成功 |
| query_id | 支付校验订单号 |

### 确认订单

##### 请求事例：

    {"user_info":"1609|2100297844|2003","unique_id":"60110d281a65d320ffdc4f95","open_id":"1609","signeddata":"{\"orderId\":\"GPA.3382-9280-8672-73304\",\"packageName\":\"com.xm.palace.beauty\",\"productId\":\"beauty_00099_1\",\"purchaseTime\":1611730221231,\"purchaseState\":0,\"purchaseToken\":\"hmenkbjjojiickomocmmdfbf.AO-J1OzuUszV_sTqUl_xjFInC0Zjhh0l7OUnKjcwW7mGgdTgYc1SGW_LZnb1TSDGRwAdacba81J2jVX7Eks2gUoC8MTIwTf16w\",\"obfuscatedAccountId\":\"1609|2100297844|2003\",\"obfuscatedProfileId\":\"60110d281a65d320ffdc4f95\",\"acknowledged\":false}","signature":"A3Hr2ptyCj88EOo1f1F4LDRaI9PZ43vxOUDJLSn3aKcUtcWc4Tcx8Xx\/3VYZYZkiiogmcxyt0Wqic7dEQ5LAuYYt5\/juckUh3nXZ31uORIP2f8voj0lZZXMNGaw00kNhZh7kCMJxljoG9GlPzSEScxjnsGB6TFfuckVxBBP8+rwVe5Z14L6xHrAQK1LYcbdeD1GRXl6OGhkO6TE2\/W3I\/gd0kd7l3GfrtmZO4qdrKZZpyy9clbHnnj7NfktTQg5nsd6QxnfftYZ+OR0PjzVW1Hqvl8Dlgx5DdH8vHeSwcXismykLJitcAUD2OnWnzMZjwNHZyExVz5V6ztBaLrMuJQ==","query_id":"60110d281a65d320ffdc4f95","product_id":"beauty_00099_1","app_id":"6007e26eb6ee064428e16d96"}

    请求方式： POST json字符串

| 参数 | 说明 | 备注 |
|----------|---------|------|
| open_id | 登录返回的数据 |  |
| signeddata | 公共订单号 | google内购传 |
| signature | 公共订单号 | google内购传 |
| query_id | 创建订单返回 |  |
| product_id | 内购id |  |
| app_id | 运营给的参数 |  |

#### 返回事例： 

    success

| 参数 | 说明 |
|------------------------|---------|
| success | 支付成功 |

## 打开个人中心(和前端交互)

    请求链接： https://sdk.hahplatform.com/static/sdk1_0_0/client.html?action=user&app_id=6007e26eb6ee064428e16d96&app_key=4c3ce5d31f10cfb3922c652063f519ed&open_id=1605&login_key=ffc8ee95ab85efe4fc4d60a74535cd3c&uuid=&idfv=&device_info=10&ver=20210127&timestamp=1611716804191&lng=en-US

| 参数 | 说明 |
|------------|---------|
| action | 动作，打开个人中心就为 user |
| app_id | 运营给的参数 |
| app_key | 运营给的参数 |
| open_id | 登录返回的 |
| login_key | 登录返回的 |
| timestamp | 时间戳 |
| lng | 当前用户的语言 |

## 前端返回
    
    说明：一般情况返回的数据格式为：sdk://exit?action=xxx&type=xxx&其他参数=xxx ,当 host 为 exit 时，需要你处理结果后关闭页面 , 通过 action 确定要处理的是何种行为的数据，通过 type 确定当 action一样 时的 子行为 数据（type不一定有）

### 事件返回

    返回的链接：sdk://event?action=event&eventName=jump&msg=guest&eventTime=0

| 参数 | 说明 |
|------------|---------|
| action | event |
| eventName | 事件名 |
| msg | 事件描述 |
| eventTime | 消耗时间 |

### 登录返回

    返回的链接：sdk://exit?action=login&birthday=&float_button=1&kefu=&login_count=1&login_key=32263921f4de55eb8399794a2fb84a59&notify_url=https%3A%2F%2Fsdk.hahplatform.com%2Fservice%2Fconfirm%2Fgoogle%2F5458c012e138231304af4216&open_id=1607&pay_channel_id=5458c012e138231304af4216&share_pic=&share_str=&timestamp=1611718040&token=5fe0a1b6b3d4b408f9c4661289c4f120

| 参数 | 说明 |
|------------|---------|
| action | 返回的事件名 |
| birthday | 生日日期 |
| float_button | 悬浮球 |
| kefu | 客服 |
| login_count | 登录次数 |
| login_key | login_key |
| notify_url | 确认订单地址 |
| open_id | open_id |
| pay_channel_id | pay_channel_id |
| share_pic | facebook分享的图片链接 |
| share_str | facebook分享的图片描述 |
| timestamp | 时间戳 |
| token | token |

### 切换账号返回

    返回的链接：sdk://exit?action=user&type=changeAccount

| 参数 | 说明 |
|------------|---------|
| action | user |
| type | changeAccount |

### 页面的x关闭页面返回

    返回的链接：sdk://exit?action=finish

| 参数 | 说明 |
|------------|---------|
| action | finish |

### 选择语言返回

    返回的链接：sdk://exit?action=user&type=changeLng&language=en-US

    注意：语言切换成功后需重新打开个人中心页面

| 参数 | 说明 |
|------------|---------|
| action | user |
| type | changeLng |
| language | 当前用户选择时哪种语言 |

### 游客账号登录点击去绑定返回

    返回的链接：sdk://exit?action=user&type=HighAccount

    注意：收到通知后需重新打开个人中心页面并在链接后台加上参数 open=HighAccount

| 参数 | 说明 |
|------------|---------|
| action | user |
| type | HighAccount |

### 前端通过js调用原生接口

| 方法名 | 说明 |
|------------|---------|
| facebookLogin | facebook登录 |
| googleLogin | google登录 |
| twitterLogin | 推特登录 |
| bindFacebook | 绑定facebook |
| unbindFacebook | 解绑facebook |
| bindGoogle | 绑定google |
| unbindGoogle | 解绑谷歌 |
| bindTwitter | 绑定推特 |
| unbindTwitter | 解绑推特 |